
### Contributing

We welcome support for both issues and pull request to `react-weui`. Feel welcome if you have any suggestion and requests.

### Issues

The issue tracker is the preferred channel for bug reports, features requests and submitting pull requests, but please respect the following restrictions:

- Please do not use the issue tracker for personal support requests.
- Please do not open issues or pull requests regarding the code in React or WeUI (open them in their respective repositories).

Note: Occasionally issues are opened that are unclear, or we cannot verify them. When the issue author has not responded to our questions for verification within 21 days then we will close the issue.

### Tests

All commits that fix bugs or add features need a test.

### Code Style

Please adhere to the current code styling. All codes should be look as it is written by one person.

We use ESLint for all JavaScript Linting. There should be no linting errors and no new warnings for new work.
You are welcome to configure your editor to use ESLint or the npm test command will run unit tests and the linter.

### Visual Changes

When making a visual change, if at all feasible please provide screenshots and/or screencasts of the proposed change.
This will help us to understand the desired change easier.
